<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css"
        integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <style>
        p {
            color: gray;
        }

        .row-center {
            display: flex;
            justify-content: center;
        }

        .column-2 {
            background: linear-gradient(162.21deg, #517879 4.83%, #1E3E57 103.44%);
            display: flex;
            flex-direction: column;
            justify-content: center;
            align-items: center;
            flex-wrap: wrap;
        }

        .jumbotron {
            background: linear-gradient(162.21deg, #0b3d3f 4.83%, #427186 103.44%);
        }
    </style>
</head>

<body>
    <form id="signup-form">
        <div class="container jumbotron" style="width: 100%;height: 1024px;">
            <div class="container">
                <div class="row">
                    <div class="col col-sm-6 col-md-6 col-lg-6" style="background-color: white;">
                        <div class="container" style="width: 70%;height: 70vh;">
                            <div class="row">
                                <h2>Let’s get you started</h2>
                            </div>
                            <div class="row" style="margin-top:20px">
                                <label for="fullname">Full name</label>
                                <input id="fullname" class="form-control" placeholder="Ade Tiger" />
                            </div>
                            <div class="row">
                                <label for="email">Email address</label>
                                <input id="email" class="form-control" placeholder="yourname@email.com" />
                            </div>
                            <div class="row">
                                <label for="password">Create password</label>
                                <input type="password" id="password" class="form-control" placeholder="********" />
                                <p>Password must contain a minimum of 8 characters</p>
                                <p>Password must contain at least one symbol e.g. @, !</p>
                            </div>
                            <div class="row">
                                <button type="submit" style="margin-top: 20px;width: 100%;" class="btn btn-dark">Sign Up</button>
                            </div>
                            <div class="row row-center" style="margin-top:50px">
                                <p>Already a user?<span><button style="color: #476D73;"
                                            class="btn btn-link">Login</button></span></p>
                            </div>
                        </div>
                    </div>
                    <div class="col col-sm-6 col-md-6 col-lg-6 column-2">
                        <div class="row" style="width: 60%;">
                            <h1 style="color: white;">“Creativity is intelligence having fun”</h1>
                        </div>
                        <div class="row" style="width: 60%;">
                            <h6 style="color: white;">-Albert Einstein</h6>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </form>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    const gPASSWORD_LENGTH_MIN = 8
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    var signUpForm = document.getElementById("signup-form")
    signUpForm.addEventListener("submit", (e) => {
        
        e.preventDefault()
        // B0 Khoi tao doi tuong
        var User = {
            fullname: "",
            email: "",
            password: ""
        }
        // B1 Thu thap du lieu
        getDataToObject(User)
        // B2 Kiem tra du lieu
        var validate = isDataValidate(User)
        if(validate==true){
            // B3 Goi API xu ly
            var xhr = new XMLHttpRequest()
            processApi(xhr)
            xhr.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_CREATED) {
                    var vSignUpInfo = xhr.responseText;
                    //B4 Xu Ly Hien Thi
                    console.log(vSignUpInfo);
                }
            }
        }
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    /* Ham thu thap du lieu cho doi tuong User
    Input la doi tuong can thu thap du lieu
    Truy xuat cac thong tin tu form va gan vao doi tuong*/
    function getDataToObject(paramObject) {
        // Truy xuat form
        var vFullnameInput = document.getElementById("fullname")
        var vEMailInput = document.getElementById("email")
        var vPasswordInput = document.getElementById("password")
        // Gan vao doi tuong
        paramObject.fullname = vFullnameInput.value.trim();
        paramObject.email = vEMailInput.value.trim();
        paramObject.password = vPasswordInput.value.trim();
    }
    /* Ham kiem tra du lieu
    Kiem tra cac input co rong khong
    Email co dung dinh dang khong
    Mat khau co du do dai khong*/
    function isDataValidate(paramObject) {
        if (paramObject.fullname=="") {
            alert("Hãy nhập Fullname")
            return false
        }
        if (isEmailValidate(paramObject.email) == false) {
            alert("Email không hợp lệ")
            return false
        }
        if (paramObject.password.length < gPASSWORD_LENGTH_MIN) {
            alert("Password phải có ít nhất 8 ký tự")
            return false
        }
        if (checkPassword(paramObject.password) == false) {
            alert("Password phải có ít nhất 1 ký tự đặc biệt ví dụ: @, !")
            return false
        }
        return true
    }
    // Ham kiem tra email
    function isEmailValidate(paramEmail) {
        var re = /^(([^<>()[\]\.,;:\s@\"]+(\.[^<>()[\]\.,;:\s@\"]+)*)|(\".+\"))@(([^<>()[\]\.,;:\s@\"]+\.)+[^<>()[\]\.,;:\s@\"]{2,})$/i;
        return re.test(paramEmail);
    }
    //Ham kiem tra password
    function checkPassword(paramPassword) {
        var paswd = /^(?=.*[!@#$%^&*])[a-zA-Z0-9!@#$%^&*]{8,25}$/;
        return paswd.test(paramPassword)
    }
    function processApi(paramXmlHttp){
        paramXmlHttp.open("POST", gBASE_URL, true)
        paramXmlHttp.send()
    }
</script>

</html>